/*
  Copyright 1996-2003  Simon Whiteside

* $Id: StatementStepper.java,v 1.3 2003/01/22 18:26:34 simkin_cvs Exp $
*/

package simkin;
import java.util.Hashtable;

/**
 * This interface is implemented by objects which are called by the Interpreter when statements are executed
 */
public interface StatementStepper {
    /** This method is called each time a statement is executed by the interpreter, just before the statement is performed
     * @return false to halt the execution of the current method
     * @param frame the current stack frame
     * @param statement_type an integer indicating the type of statement, a constant s_ value from the ParseNode class
     */
    boolean statementExecuted(StackFrame frame,int statement_type);
    /** This method is called each time a compound statement is executed by the interpreter, just before the statement is performed
     * @return false to halt the execution of the current method
     * @param frame the current stack frame
     */
    boolean compoundStatementExecuted(StackFrame frame);
    /**
     * This method is called if an exception is encountered while executing a script.
     * @param frame the current stack frame
     * @param e the exception that has occurred
     * @return true to throw the exception, false to ignore and continue
     */
    boolean exceptionEncountered(StackFrame frame,Exception e);
}
