/*
  Copyright 1996-2003  Simon Whiteside

* $Id: TraceCallback.java,v 1.6 2003/01/22 18:26:34 simkin_cvs Exp $
*/

package simkin;

/**
 * This interface is implemented by objects which provide a tracing facility. 
 * Put the tracer in place by calling the {@link simkin.Interpreter#setTraceCallback setTraceCallback} method in {@link simkin.Interpreter Interpreter}
 */
public interface TraceCallback {
    /** 
     * this method is called when a trace message is generated.
     */
    public void trace(String s);
    /** 
     * this method is called an exception is shown in the trace
     */
    public void trace(Exception e);
}
