/*
  Copyright 1996-2003  Simon Whiteside

  $Id: TreeNodeEnumerator.java,v 1.2 2003/01/22 18:26:34 simkin_cvs Exp $
*/
package simkin;
import java.util.*;

/**
 * This class enumerates the elements in a TreeNode
 * 
 *
*/
public class TreeNodeEnumerator {
    TreeNode m_TreeNode;
    String m_TagName="";
    int m_NodeNum=0;
    /**
     * Constructor - enumerates over every child node of this object
     */
    public TreeNodeEnumerator(TreeNode treeNodeObject){
	m_TreeNode=treeNodeObject;
    }
    /**
     * Constructor - enumerates over children of this object with the matching tag
     */
    public TreeNodeEnumerator(TreeNode treeNodeObject,String tagName){
	m_TreeNode=treeNodeObject;
	m_TagName=tagName;
	// first wind forward to the first occurrence of the tag
	findNextNode();
    }
    /**
     * returns the next object in the enumeration - or null if there are no more
     */
    public TreeNode next(){
	Vector nodes=m_TreeNode.getItems();
	TreeNode ret=null;
	if (nodes!=null && m_NodeNum<nodes.size()){
	    ret=(TreeNode)nodes.elementAt(m_NodeNum);
	    if (m_TagName.length()>0)
		findNextNode();
	    else
		m_NodeNum++;
	}
	return ret;
    }
    /**
     * This method resets the enumeration to the beginning - you can now iterate over the list again
     */
    public void reset(){
	m_NodeNum=0;
	findNextNode();
    }
    /**
     * this method winds m_NodeNum onto the next matching element - or beyond the end of the list for the end of enumeration
     */
    void findNextNode(){
	Vector nodes=m_TreeNode.getItems();
	if (nodes!=null)
	    for (;m_NodeNum<nodes.size();m_NodeNum++){
		TreeNode node=(TreeNode)nodes.elementAt(m_NodeNum);
		if (node.label().equals(m_TagName)){
		    break;
		}
	    }
    }
}
