/*
  $Id: TreeNodeIterator.java,v 1.3 2003/01/22 18:26:34 simkin_cvs Exp $
  (c) 1996-2003 Simon Whiteside
*/

package simkin;
import java.util.*;

/**
 * This class provides a means of iterating over the children of a TreeNode
 */
final public class TreeNodeIterator  {
    TreeNode m_Node;
    int m_Index;
    /**
     * Constructor - is passed a TreeNode whose children will be iterated
     */
    public TreeNodeIterator(TreeNode node){
	m_Node=node;
	m_Index=0;
    }
    /**
     * This function returns true if the iteration has not yet been finished
     */
    public boolean hasMoreElements(){
	return m_Index<m_Node.numChildren();
    }
    /**
     * this function returns the next element in the iteration
     * @exception NoSuchElementException - this is thrown if the function is called after the iteration has finished
     */
    public TreeNode nextElement() throws NoSuchElementException{
	TreeNode elt=null;
	if (m_Index<m_Node.numChildren()){
	    elt=m_Node.nthChild(m_Index);
	    m_Index++;
	}else
	    throw new NoSuchElementException();
	return elt;
    }
}
